//====================================================================================//
//                                                                                    //
//                                   Simtime class                                    //
//                                                                                    //
//====================================================================================//
//  This File:   simtime.cpp                      Language: C++  (xlC and CC)         //
//  Software:    SIMULEAU                                                             //
//====================================================================================//
//  Creation:    11/may/16                        by: Leonardo.Brenner@lsis.org       //
//  Last Change: 11/may/16                        by: Leonardo.Brenner@lsis.org       //
//====================================================================================//
#include "simuleau.h"


//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
Simtime::Simtime()
{
  currentdate  = 0.0;
  previousdate = 0.0;
  nextdate     = 0.0;
}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
Simtime::~Simtime()
{
  //dtor
}

//------------------------------------------------------------------------------
// Set all dates to zero
//------------------------------------------------------------------------------
void Simtime::Reset()
{
	previousdate = currentdate = nextdate = 0.0;
}

//------------------------------------------------------------------------------
// Permute dates
//------------------------------------------------------------------------------
void Simtime::Permute()
{
	previousdate = currentdate;
	currentdate = nextdate;
}

//------------------------------------------------------------------------------
// Compute steptime
//------------------------------------------------------------------------------
double Simtime::StepTime()
{
  return (currentdate - previousdate);
}

//------------------------------------------------------------------------------
// Set the next date
//------------------------------------------------------------------------------
void Simtime::SetNextDate(double _nd)
{
  nextdate = _nd;
}


//------------------------------------------------------------------------------
// Return the previous date
//------------------------------------------------------------------------------
double Simtime::GetPreviousDate()
{
  return previousdate;
}

//------------------------------------------------------------------------------
// Return the current date
//------------------------------------------------------------------------------
double Simtime::GetCurrentDate()
{
  return currentdate;
}

//------------------------------------------------------------------------------
// Return the next date
//------------------------------------------------------------------------------
double Simtime::GetNextDate()
{
  return nextdate;
}

//------------------------------------------------------------------------------
// Print
//------------------------------------------------------------------------------
void Simtime::Print(ofstream &fout)
{
	cout << "Previous date = " << previousdate;
	cout << "Current date =  " << currentdate;
	cout << "Next date =     " << nextdate;
}
